// Strings.cpp
#define UNICODE
#define _UNICODE
#include  <windows.h>
#include  "string.h"
#include  "stdio.h"
#include  "Strings.h"
#include  "tchar.h"


String::String()
{
 #ifdef debug
 _tprintf(_T("Entering String Uninitialized Constructor!\n"));
 #endif
 this->lpBuffer=new TCHAR[16];
 this->lpBuffer[0]=0;
 this->iLen=0;
 this->iCapacity=15;
 #ifdef debug
 _tprintf(_T("  this = %p\n"),this);
 _tprintf(_T("Leaving String Uninitialized Constructor!\n\n"));
 #endif
}


String& String::operator=(const TCHAR* pStr)  // Assign TCHAR* to String
{
 #ifdef debug
 _tprintf(_T("Entering String::operator=(TCHAR*)\n"));
 _tprintf(_T("  this            = %p\n"),this);
 _tprintf(_T("  pStr            = %s\n"),pStr);
 _tprintf(_T("  _tcslen(pStr)   = %Iu\n"),_tcslen(pStr));
 _tprintf(_T("  this->iCapacity = %Iu\n"),this->iCapacity);
 #endif
 size_t iNewLen=_tcslen(pStr);
 if(iNewLen>this->iCapacity)
 {
    #ifdef debug
    _tprintf(_T("  Had To Reallocate!\n"));
    #endif
    delete [] this->lpBuffer;
    int iNewSize=(iNewLen*EXPANSION_FACTOR/16+1)*16;
    this->lpBuffer=new TCHAR[iNewSize];
    this->iCapacity=iNewSize-1;
    #ifdef debug
    _tprintf(_T("  this->iCapacity = %Iu\n"),this->iCapacity);
    #endif
 }
 _tcscpy(this->lpBuffer,pStr);
 this->iLen=iNewLen;
 #ifdef debug
 _tprintf(_T("  this->lpBuffer  = %s\n"),this->lpBuffer);
 _tprintf(_T("Leaving String::operator=(TCHAR*)\n\n"));
 #endif
   
 return *this;
}


int String::ParseCount(const TCHAR delimiter)   //returns one more than # of
{                                               //delimiters so it accurately
 int iCtr=0;                                    //reflects # of strings delimited
 TCHAR* p;                                      //by delimiter.

 p=this->lpBuffer;
 while(*p)
 {
   if(*p==delimiter)
      iCtr++;
   p++;
 }

 return ++iCtr;
}


void String::Parse(String* pStr, TCHAR delimiter, size_t iParseCount)
{
 TCHAR* pBuffer=new TCHAR[this->iLen+1];
 if(pBuffer)
 {
    TCHAR* p=pBuffer;
    TCHAR* c=this->lpBuffer;
    while(*c)
    {
       if(*c==delimiter)
          *p=0;
       else
          *p=*c;
       p++, c++;
    }
    *p=0, p=pBuffer;
    for(size_t i=0; i<iParseCount; i++)
    {
        pStr[i]=p;
        p=p+pStr[i].iLen+1;
    }
    delete [] pBuffer;
 }
}


void String::LTrim()
{
 size_t iCt=0;

 for(size_t i=0; i<this->iLen; i++)
 {
     if(this->lpBuffer[i]==9||this->lpBuffer[i]==10||this->lpBuffer[i]==13||this->lpBuffer[i]==32)
        iCt++;
     else
        break;
 }
 if(iCt)
 {
    for(size_t i=iCt; i<=this->iLen; i++)
        this->lpBuffer[i-iCt]=this->lpBuffer[i];
 }
 this->iLen=this->iLen-iCt;
}


TCHAR* String::lpStr()
{
 return this->lpBuffer;
} 


#ifdef CONSOLE_OUTPUT 
   void String::Print(bool blnCrLf)
   {
    _tprintf(_T("%s"),this->lpBuffer);
    if(blnCrLf)
       _tprintf(_T("\n"));
   }

   
   void String::Print(const TCHAR* pStr, bool blnCrLf)
   {
    _tprintf(_T("%s%s"),pStr,lpBuffer);
    if(blnCrLf)
       _tprintf(_T("\n"));
   }
#endif


String::~String()
{
 #ifdef debug
 _tprintf(_T("Entering String Destructor!\n"));
 _tprintf(_T("  this = %p\n"),this);
 #endif
 delete [] this->lpBuffer;
 #ifdef debug
 _tprintf(_T("Leaving String Destructor!\n\n"));
 #endif
}
// End Strings.cpp
